//+------------------------------------------------------------------+
//|                                                DT-Smooth-HTF.mq4 |
//|                      Copyright  2009, MetaQuotes Software Corp. |
//|                                        http://www.metaquotes.net |
//+------------------------------------------------------------------+
#property copyright "Copyright  2009, MetaQuotes Software Corp."
#property link      "http://www.metaquotes.net"

#property indicator_chart_window
//#property indicator_separate_window
#property indicator_buffers 7
#property indicator_color1 Aqua
#property indicator_color2 Red
#property indicator_color3 Blue
#property indicator_color4 Silver
#property indicator_color5 Silver
#property indicator_color6 Silver
#property indicator_color7 Yellow

//---- input parameters
/*************************************************************************
PERIOD_M1   1
PERIOD_M5   5
PERIOD_M15  15
PERIOD_M30  30 
PERIOD_H1   60
PERIOD_H4   240
PERIOD_D1   1440
PERIOD_W1   10080
PERIOD_MN1  43200
You must use the numeric value of the timeframe that you want to use
when you set the TimeFrame' value with the indicator inputs.
---------------------------------------
PRICE_CLOSE    0 Close price. 
PRICE_OPEN     1 Open price. 
PRICE_HIGH     2 High price. 
PRICE_LOW      3 Low price. 
PRICE_MEDIAN   4 Median price, (high+low)/2. 
PRICE_TYPICAL  5 Typical price, (high+low+close)/3. 
PRICE_WEIGHTED 6 Weighted close price, (high+low+close+close)/4. 
You must use the numeric value of the Applied Price that you want to use
when you set the 'applied_price' value with the indicator inputs.
---------------------------------------
MODE_SMA    0 Simple moving average, 
MODE_EMA    1 Exponential moving average, 
MODE_SMMA   2 Smoothed moving average, 
MODE_LWMA   3 Linear weighted moving average. 
You must use the numeric value of the MA Method that you want to use
when you set the 'ma_method' value with the indicator inputs.

**************************************************************************/
extern int TimeFrame=240;
extern string Currency;
extern int MAPeriod=8;
extern int ma_shift=0;
extern int ma_method=MODE_SMA;
extern int applied_price=PRICE_CLOSE;
extern bool UseLevels=False;
extern int Level0=0;
extern int Level1=0;
extern int Level2=0;
extern int Level3=0;
extern int Level4=0;
extern int Level5=0;


double ExtMapBuffer1[];
double ExtMapBuffer2[];
double ExtMapBuffer3[];
double ExtMapBuffer4[];
double ExtMapBuffer5[];
double ExtMapBuffer6[];
double ExtMapBuffer7[];
double Buffer[];
   int i, limit;
  
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
  //Draw();
 
//---- indicator line
   SetIndexBuffer(0,ExtMapBuffer1);
   SetIndexStyle(0,DRAW_SECTION,STYLE_SOLID);   
   SetIndexBuffer(1,ExtMapBuffer2);
   SetIndexStyle(1,DRAW_LINE,STYLE_SOLID);
   SetIndexBuffer(2,ExtMapBuffer3);
   SetIndexStyle(2,DRAW_SECTION,STYLE_SOLID);
   SetIndexBuffer(3,ExtMapBuffer4);
   SetIndexStyle(3,DRAW_LINE,STYLE_SOLID);
   SetIndexBuffer(4,ExtMapBuffer5);
   SetIndexStyle(4,DRAW_LINE,STYLE_SOLID);
   SetIndexBuffer(5,ExtMapBuffer6);
   SetIndexStyle(5,DRAW_LINE,STYLE_SOLID);
   SetIndexBuffer(6,ExtMapBuffer7);
   SetIndexStyle(6,DRAW_LINE);
   SetIndexEmptyValue(0,0.0);
   SetIndexEmptyValue(2,0.0);

//----
   return(0);
 }
//+------------------------------------------------------------------+
//| MTF Moving Average                                   |
//+------------------------------------------------------------------+
int start()
  {
      
      Draw();
      

   return(0);
  }
//+------------------------------------------------------------------+

void Draw()
{
   datetime TimeArray[];
   int    y=0,counted_bars=0;//IndicatorCounted();
   
   ArrayInitialize(ExtMapBuffer1,0.0);
   ArrayInitialize(ExtMapBuffer3,0.0);
// Plot defined time frame on to current time frame
   ArrayCopySeries(TimeArray,MODE_TIME,NULL,TimeFrame); 
   limit=Bars-counted_bars;
   for(i=0,y=0;i<limit;i++)
   {
  
      //only place available htf values into buffer. index style DRAW_SECTION will interpolate.
      if (Time[i]<TimeArray[y])
      { 
         ExtMapBuffer3[i-1]=iMA(Currency,TimeFrame,MAPeriod,ma_shift,ma_method,applied_price,y) ;// smooth the other side of steps
         y++; 
         ExtMapBuffer1[i]=iMA(Currency,TimeFrame,MAPeriod,ma_shift,ma_method,applied_price,y) ; //normal smooth line
      }
      //the steps
      ExtMapBuffer2[i]=iMA(Currency,TimeFrame,MAPeriod,ma_shift,ma_method,applied_price,y) ; //Red line 
   }  
   //draw current bars
   ExtMapBuffer3[0]=iMA(Currency,TimeFrame,MAPeriod,ma_shift,ma_method,applied_price,0) ; 
   ExtMapBuffer1[0]=iMA(Currency,TimeFrame,MAPeriod,ma_shift,ma_method,applied_price,0) ; 

//-------------------
return(0);
}